<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Slide Project</title>
    <style>
      html,
      body {
        box-sizing: border-box;
        padding: 0;
        margin: 0;
        text-align: center;
      }
      *,
      *:before,
      *:after {
        box-sizing: inherit;
      }
      .clearfix:after {
        content: "";
        display: block;
        clear: both;
        float: none;
      }
      .title {
        margin-bottom: 0;
        text-align: center;
        font-size: 30px;
        color: #333;
      }
      #container {
        width: 1000px;
        margin: auto;
      }
      .slide_wrap {
        position: relative;
        width: 400px;
        margin: auto;
        padding-bottom: 30px;
      }
      .slide_box {
        width: 100%;
        margin: auto;
        overflow-x: hidden;
      }
      .slide_content {
        display: table;
        float: left;
        width: 400px;
        height: 400px;
      }
      .slide_content > p {
        display: table-cell;
        vertical-align: middle;
        text-align: center;
        font-size: 100px;
        font-weight: bold;
        color: #555;
      }
      .slide_content.slide01 {
        background: #ddbdff;
      }
      .slide_content.slide02 {
        background: #9fd6c2;
      }
      .slide_content.slide03 {
        background: #abe2f7;
      }
      .slide_content.slide04 {
        background: #f08c78;
      }
      .slide_content.slide05 {
        background: #fbdb65;
      }
      .slide_btn_box > button {
        position: absolute;
        top: 50%;
        margin-top: -45px;
        width: 60px;
        height: 60px;
        font-size: 16px;
        color: #999;
        background: none;
        border: 1px solid #ddd;
        cursor: pointer;
      }
      .slide_btn_box > .slide_btn_prev {
        left: -100px;
      }
      .slide_btn_box > .slide_btn_next {
        right: -100px;
      }
      .slide_pagination {
        position: absolute;
        left: 50%;
        bottom: 0;
        list-style: none;
        margin: 0;
        padding: 0;
        transform: translateX(-50%);
      }
      /* dot_active 가 추가 되면, 배경색이 0.3 초뒤에 바뀜*/
      .slide_pagination .dot {
        display: inline-block;
        width: 15px;
        height: 15px;
        margin: 0 5px;
        overflow: hidden;
        background: #ddd;
        border-radius: 50%;
        transition: 0.3s;
      }
      .slide_pagination .dot.dot_active {
        background: #333;
      }
      .slide_pagination .dot a {
        display: block;
        width: 100%;
        height: 100%;
      }
    </style>
  </head>
  <body>
    <h1 class="title">Carousel Project</h1>

    <div id="container">
      <div class="slide_wrap">
        <div class="slide_box">
          <div class="slide_list clearfix">
            <div class="slide_content slide01">
              <p>1</p>
            </div>
            <div class="slide_content slide02">
              <p>2</p>
            </div>
            <div class="slide_content slide03">
              <p>3</p>
            </div>
            <div class="slide_content slide04">
              <p>4</p>
            </div>
            <div class="slide_content slide05">
              <p>5</p>
            </div>
          </div>
          <!-- // .slide_list -->
        </div>
        <!-- // .slide_box -->
        <div class="slide_btn_box">
          <button type="button" class="slide_btn_prev">Prev</button>
          <button type="button" class="slide_btn_next">Next</button>
        </div>
        <!-- // .slide_btn_box -->
        <ul class="slide_pagination"></ul>
        <!-- // .slide_pagination -->
      </div>
      <!-- // .slide_wrap -->
    </div>
    <script>
      (function () {
        const slideList = document.querySelector(".slide_list");
        const slideContents = document.querySelectorAll(".slide_content");
        const slideBtnNext = document.querySelector(".slide_btn_next");
        const slideBtnPrev = document.querySelector(".slide_btn_prev");
        const pagination = document.querySelector(".slide_pagination");
        const slideLen = slideContents.length;
        const slideWidth = 400;
        const slideSpeed = 300;
        const startNum = 0;

        slideList.style.width = slideWidth * (slideLen + 2) + "px";

        let firstChild = slideList.firstElementChild;
        let lastChild = slideList.lastElementChild;
        let clonedFirst = firstChild.cloneNode(true);
        let clonedLast = lastChild.cloneNode(true);

        slideList.appendChild(clonedFirst);
        slideList.insertBefore(clonedLast, slideList.firstElementChild);

        let pageChild = "";
        for (let i = 0; i < slideLen; ++i) {
          pageChild += '<li class="dot';
          pageChild += i === startNum ? " dot_active" : "";
          pageChild += '" data-index="' + i + '"><a href="#"></a></li>';
        }

        pagination.innerHTML = pageChild;
        const pageDots = document.querySelectorAll(".dot");

        slideList.style.transform = "translate3d(-" + slideWidth * (startNum + 1) + "px, 0px, 0px)";

        let curIndex = startNum;
        let curSlide = slideContents[curIndex];
        curSlide.classList.add("slide_active");

        slideBtnNext.addEventListener("click", function () {
          if (curIndex <= slideLen - 1) {
            slideList.style.transition = slideSpeed + "ms";
            slideList.style.transform = "translate3d(-" + slideWidth * (curIndex + 2) + "px, 0px, 0px)";
          }
          if (curIndex == slideLen - 1) {
            setTimeout(function () {
              slideList.style.transition = "0ms";
              slideList.style.transform = "translate3d(-" + slideWidth + "px, 0px, 0px)";
            }, slideSpeed);
            curIndex = -1;
          }

          curSlide.classList.remove("slide_active");
          pageDots[curIndex === -1 ? slideLen - 1 : curIndex].classList.remove("dot_active");
          curSlide = slideContents[++curIndex];
          curSlide.classList.add("slide_active");
          pageDots[curIndex].classList.add("dot_active");
        });

        slideBtnPrev.addEventListener("click", function () {
          if (curIndex >= 0) {
            slideList.style.transition = slideSpeed + "ms";
            slideList.style.transform = "translate3d(-" + slideWidth * curIndex + "px, 0px, 0px)";
          }
          if (curIndex == 0) {
            setTimeout(function () {
              slideList.style.transition = "0ms";
              slideList.style.transform = "translate3d(-" + slideWidth * slideLen + "px, 0px, 0px)";
            }, slideSpeed);
            curIndex = slideLen;
          }
          curSlide.classList.remove("slide_active");
          pageDots[curIndex == slideLen ? 0 : curIndex].classList.remove("dot_active");
          curSlide = slideContents[--curIndex];
          curSlide.classList.add("slide_active");
          pageDots[curIndex].classList.add("dot_active");
        });

        let curDot;
        Array.prototype.forEach.call(pageDots, function (dot, i) {
          dot.addEventListener("click", function (e) {
            e.preventDefault();
            curDot = document.querySelector(".dot_active");
            curDot.classList.remove("dot_active");

            curDot = this;
            this.classList.add("dot_active");

            curSlide.classList.remove("slide_active");
            curIndex = Number(this.getAttribute("data-index"));
            curSlide = slideContents[curIndex];
            curSlide.classList.add("slide_active");
            slideList.style.transition = slideSpeed + "ms";
            slideList.style.transform = "translate3d(-" + slideWidth * (curIndex + 1) + "px, 0px, 0px)";
          });
        });
      })();
    </script>
  </body>
</html>
